/* jshint undef: true, unused: true */
/* global require, module, java */

var _ = require("lodash");

var JDate = java.util.Date;
var SimpleDateFormat = java.text.SimpleDateFormat;

var LEGACY_DATE_FORMAT = new SimpleDateFormat("MM/dd/yyyy");
var DATE_FORMAT = new SimpleDateFormat("yyyy-MM-dd");

var TIME_FORMAT_24H = new SimpleDateFormat("HH:mm");
var TIME_FORMAT_12H = new SimpleDateFormat("hh:mm a");

var DATE_TIME_FORMAT_24H = new SimpleDateFormat("yyyy-MM-dd HH:mm");
var DATE_TIME_FORMAT_12H = new SimpleDateFormat("yyyy-MM-dd hh:mm a");

var HOURS = java.time.temporal.ChronoUnit.HOURS;
function parseStartTimeParameters (startDate, startTime)
{
    var format = _(startTime).includes("AM") || _(startTime).includes("PM") ? DATE_TIME_FORMAT_12H
                                                                            : DATE_TIME_FORMAT_24H;
    return format.parse(startDate + " " + startTime).getTime();
}

function parseDurationParameter (value)
{
    var parts = value.split(":");
    return 60 * parseInt(parts[0]) + parseInt(parts[1]);
}

function formatDurationMinutes (value)
{
    var hours = parseInt(value / 60);
    var minutes = value % 60;
    return hours + ":" + minutes;
}

function getNextHourOfToday ()
{
    return JDate.from(
        java.time.Instant.now().plus(1, HOURS).truncatedTo(HOURS)
    );
}

function now ()
{
    return new JDate();
}

module.exports = {
    LEGACY_DATE_FORMAT: LEGACY_DATE_FORMAT,
    DATE_FORMAT: DATE_FORMAT,
    TIME_FORMAT_12H: TIME_FORMAT_12H,
    TIME_FORMAT_24H: TIME_FORMAT_24H,
    now: now,
    parseStartTimeParameters: parseStartTimeParameters,
    parseDurationParameter: parseDurationParameter,
    formatDurationMinutes: formatDurationMinutes,
    getNextHourOfToday: getNextHourOfToday
};
